## yyjson 0.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(yyjson VERSION 0.1.0)


# Compile Options, see yyjson.h for more explanation.
option(YYJSON_DISABLE_READER "Disable JSON reader" OFF)
option(YYJSON_DISABLE_WRITER "Disable JSON writer" OFF)
option(YYJSON_DISABLE_FP_READER "Disable custom floating-point number reader" OFF)
option(YYJSON_DISABLE_FP_WRITER "Disable custom floating-point number writer" OFF)
option(YYJSON_DISABLE_COMMENT_READER "Disable non-standard comment reader" OFF)
option(YYJSON_DISABLE_INF_AND_NAN_READER "Disable non-standard inf and nan reader" OFF)


# Build Options
option(YYJSON_BUILD_TESTS "Build all tests" OFF)
option(YYJSON_ENABLE_COVERAGE "Enable code coverage for tests" OFF)
option(YYJSON_ENABLE_VALGRIND "Enable valgrind memory checker for tests" OFF)
option(YYJSON_ENABLE_SANITIZE "Enable sanitizer for tests" OFF)
option(YYJSON_BUILD_MISC "Build misc" OFF)


# Build Type
if(XCODE OR MSVC)
    set(CMAKE_CONFIGURATION_TYPES "Debug;Release" CACHE STRING "" FORCE)
endif()
if(NOT CMAKE_BUILD_TYPE)
    message(STATUS "No build type selected, default to: Release")
    set(CMAKE_BUILD_TYPE Release)
endif()


# Library
add_library(yyjson SHARED src/yyjson.h src/yyjson.c)
target_include_directories(yyjson PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>)


# Compiler Flags
if(YYJSON_DISABLE_READER)
    add_definitions(-DYYJSON_DISABLE_READER=1)
endif()
if(YYJSON_DISABLE_WRITER)
    add_definitions(-DYYJSON_DISABLE_WRITER=1)
endif()
if(YYJSON_DISABLE_FP_READER)
    add_definitions(-DYYJSON_DISABLE_FP_READER=1)
endif()
if(YYJSON_DISABLE_FP_WRITER)
    add_definitions(-DYYJSON_DISABLE_FP_WRITER=1)
endif()
if(YYJSON_DISABLE_COMMENT_READER)
    add_definitions(-DYYJSON_DISABLE_COMMENT_READER=1)
endif()
if(YYJSON_DISABLE_INF_AND_NAN_READER)
    add_definitions(-DYYJSON_DISABLE_INF_AND_NAN_READER=1)
endif()


# Project Config
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(XcodeProperty)

if(XCODE)
    set_default_xcode_property(yyjson)
    set_xcode_deployment_version(yyjson "10.11" "9.0" "9.0" "2.0")

    set_xcode_property(yyjson GCC_C_LANGUAGE_STANDARD "c89")
    set_xcode_property(yyjson CLANG_CXX_LANGUAGE_STANDARD "c++98")
    
    set_xcode_property(yyjson OTHER_CFLAGS[variant=Debug] "-Wall -Wextra -Werror -pedantic -pedantic-errors")
    set_xcode_property(yyjson OTHER_CFLAGS[variant=Release] "-Wall -Wextra -Werror -pedantic -pedantic-errors")
elseif(MSVC)
    target_compile_options(yyjson PRIVATE $<$<C_COMPILER_ID:MSVC>:/permissive- /utf-8>)
    target_compile_options(yyjson PRIVATE $<$<CXX_COMPILER_ID:MSVC>:/permissive- /utf-8>)
endif()

if(BUILD_SHARED_LIBS)
    if(WIN32)
        target_compile_definitions(yyjson PUBLIC
            $<BUILD_INTERFACE:YYJSON_EXPORTS>
            $<INSTALL_INTERFACE:YYJSON_IMPORTS>)
    endif()
endif()


# Install
include(GNUInstallDirs)

install(TARGETS yyjson
        EXPORT yyjson-targets
        ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
        INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
install(EXPORT yyjson-targets
        FILE yyjson-config.cmake
        NAMESPACE yyjson::
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/yyjson")
install(FILES src/yyjson.h DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")


# Testing
if(YYJSON_BUILD_TESTS)
    enable_testing()

    if(XCODE)
        # Config XCTest
        find_package(XCTest REQUIRED)
        set(CMAKE_XCODE_ATTRIBUTE_CODE_SIGNING_ALLOWED "NO")
        set(CMAKE_XCODE_ATTRIBUTE_CODE_SIGNING_REQUIRED "NO")
        set(CMAKE_XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY "")
        set(YYJSON_TEST_DATA ${CMAKE_CURRENT_SOURCE_DIR}/test/data)

        # Add test cases to XCTest
        file(GLOB YYJSON_TEST_SOURCE
            "test/test_*.c"
            "test/test_*.cpp"
        )
        set(YYJSON_TEST_LINES "")
        foreach(SRC_FILE ${YYJSON_TEST_SOURCE})
            string(REGEX REPLACE "(^.*/|\\.[^.]*$)" "" SRC_NAME ${SRC_FILE})
            set(YYJSON_TEST_LINES "${YYJSON_TEST_LINES}- (void)${SRC_NAME} {\n")
            set(YYJSON_TEST_LINES "${YYJSON_TEST_LINES}    extern void ${SRC_NAME}(void);\n")
            set(YYJSON_TEST_LINES "${YYJSON_TEST_LINES}    ${SRC_NAME}();\n")
            set(YYJSON_TEST_LINES "${YYJSON_TEST_LINES}}\n\n")
        endforeach()
        configure_file(
            "${CMAKE_CURRENT_SOURCE_DIR}/test/xctest/yy_xctest.m.in"
            "${CMAKE_CURRENT_SOURCE_DIR}/test/xctest/yy_xctest.m"
            @ONLY
        )
        unset(YYJSON_TEST_LINES)

        # Add source files and search path to XCTest
        file(GLOB YYJSON_TEST_SOURCE 
            "test/test_*.c"
            "test/test_*.cpp"
            "test/util/*.h"
            "test/util/*.c"
            "test/xctest/*"
        )
        xctest_add_bundle(yyjson_tests yyjson
            ${YYJSON_TEST_SOURCE}
            ${YYJSON_TEST_DATA}
        )
        set_target_properties(yyjson_tests PROPERTIES
            MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/test/xctest/Info.plist
            RESOURCE ${YYJSON_TEST_DATA}
        )
        target_include_directories(yyjson_tests PRIVATE 
            ${CMAKE_CURRENT_SOURCE_DIR}/test/util
            ${CMAKE_CURRENT_SOURCE_DIR}/test/xctest
        )
        xctest_add_test(XCTest.yyjson yyjson_tests)

        set_default_xcode_property(yyjson_tests)
        set_xcode_deployment_version(yyjson_tests "10.11" "9.0" "9.0" "2.0")

    else()
        # Check valgrind command
        if (YYJSON_ENABLE_VALGRIND)
            find_program(MEMORYCHECK_COMMAND valgrind)
            if ("${MEMORYCHECK_COMMAND}" MATCHES "MEMORYCHECK_COMMAND-NOTFOUND")
                message(WARNING "Valgrind not found")
                unset(MEMORYCHECK_COMMAND)
            else()
                message(STATUS "Valgrind found")
                set(MEMORYCHECK_COMMAND_OPTIONS
                    --tool=memcheck
                    --leak-check=full
                    --trace-children=yes
                    --error-exitcode=1
                )
            endif()
        endif()

        # Copy test data
        file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/test/data" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
        add_definitions(-DYYJSON_TEST_DATA_PATH="${CMAKE_CURRENT_BINARY_DIR}")
        
        # Add dependency
        add_library(yyjson_test_utils
            test/util/yy_test_utils.c
            test/util/david_gay_dtoa.c
        )
        target_include_directories(yyjson_test_utils PUBLIC test/util)

        # Add test cases
        file(GLOB YYJSON_TEST_SOURCE
            "test/test_*.c"
            "test/test_*.cpp"
        )
        foreach(SRC_FILE ${YYJSON_TEST_SOURCE})
            string(REGEX REPLACE "(^.*/|\\.[^.]*$)" "" SRC_NAME ${SRC_FILE})
            add_executable(${SRC_NAME} ${SRC_FILE})
            target_link_libraries(${SRC_NAME} PRIVATE yyjson yyjson_test_utils)

            if(MEMORYCHECK_COMMAND)
                add_test(NAME ${SRC_NAME}
                         COMMAND "${MEMORYCHECK_COMMAND}" ${MEMORYCHECK_COMMAND_OPTIONS} "${CMAKE_CURRENT_BINARY_DIR}/${SRC_NAME}")
            else()
                add_test(${SRC_NAME} ${SRC_NAME})
            endif()

            set_tests_properties(${SRC_NAME} PROPERTIES TIMEOUT 60)
            message(STATUS "Add test: ${SRC_NAME}")
        endforeach()
        
        if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang")
            if (YYJSON_ENABLE_COVERAGE)
                set(COMPILE_FLAGS --coverage)
                target_compile_options(yyjson PRIVATE ${COMPILE_FLAGS})
                target_link_libraries(yyjson INTERFACE ${COMPILE_FLAGS})
            endif()
            if (YYJSON_ENABLE_SANITIZE)
                set(COMPILE_FLAGS 
                    -fsanitize=address
                    -fsanitize=undefined
                    -fsanitize=leak
                    -fsanitize-recover=all
                    -fno-omit-frame-pointer
                    -fno-optimize-sibling-calls
                    -O1
                    -g
                )
                target_compile_options(yyjson PRIVATE ${COMPILE_FLAGS})
                target_link_libraries(yyjson INTERFACE ${COMPILE_FLAGS})
            endif()
        endif()

    endif()

    # Test strict C89/C++98 compatibility
    add_executable(test_compile_c89 test/compile_ansi.c)
    target_include_directories(test_compile_c89 PRIVATE src)
    add_executable(test_compile_cxx98 test/compile_ansi.cpp)
    target_include_directories(test_compile_cxx98 PRIVATE src)

    if(MSVC)
        # set warning level 4, treat warnings as errors
        set(YYJSON_STRICT_FLAGS /W4 /WX)
        target_compile_options(test_compile_c89 PRIVATE $<$<COMPILE_LANGUAGE:C>:${YYJSON_STRICT_FLAGS}>)
        target_compile_options(test_compile_cxx98 PRIVATE $<$<COMPILE_LANGUAGE:CXX>:${YYJSON_STRICT_FLAGS}>)

    elseif(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang")

        include(CheckCCompilerFlag)
        check_c_compiler_flag("-std=c89" COMPILER_SUPPORTS_C89)
        if(COMPILER_SUPPORTS_C89)
            # check ANSI standard strictly, treat warnings as errors
            set(YYJSON_STRICT_C_FLAGS
                -std=c89
                -Wall
                -Wextra
                -Werror
                -pedantic
                -pedantic-errors
                -Wmissing-prototypes
                -Wstrict-prototypes
                -Wdouble-promotion
                -Wundef
            )
            target_compile_options(test_compile_c89 PRIVATE $<$<COMPILE_LANGUAGE:C>:${YYJSON_STRICT_C_FLAGS}>)
        endif()

        include(CheckCXXCompilerFlag)
        check_cxx_compiler_flag("-std=c++98" COMPILER_SUPPORTS_CXX98)
        if(COMPILER_SUPPORTS_CXX98)
            # check ANSI standard strictly, treat warnings as errors
            set(YYJSON_STRICT_CXX_FLAGS
                -std=c++98
                -Wall
                -Wextra
                -Werror
                -pedantic
                -pedantic-errors
            )
            target_compile_options(test_compile_cxx98 PRIVATE $<$<COMPILE_LANGUAGE:CXX>:${YYJSON_STRICT_CXX_FLAGS}>)
        endif()

    endif()

endif()


# Miscellaneous
if(YYJSON_BUILD_MISC)
    # jsoninfo
    add_executable(jsoninfo "misc/jsoninfo.c")
    target_link_libraries(jsoninfo PRIVATE yyjson)
    if(XCODE)
        set_default_xcode_property(jsoninfo)
    endif()

    # make tables
    find_package(GMP REQUIRED)
    find_package(MPFR REQUIRED)
    add_executable(make_tables "misc/make_tables.c")
    target_include_directories(make_tables PRIVATE 
        ${GMP_INCLUDE_DIR}
        ${MPFR_INCLUDES}
    )
    target_link_libraries(make_tables PRIVATE
        ${GMP_LIBRARIES}
        ${MPFR_LIBRARIES}
    )
    if(XCODE)
        set_default_xcode_property(make_tables)
    endif()
endif()

=== debian/changelog ===
yyjson (0.4.0) unstable; urgency=medium

  * Initial Release.

 -- STV Electronic GmbH <h.kempkensteffen@stv-electronic.de>  Fri, 04 Mar 2022 09:38:53 +0000

=== debian/control ===
Source: yyjson
Priority: optional
Maintainer: STV Electronic GmbH <h.kempkensteffen@stv-electronic.de>
Standards-Version: 4.4.1
Section: libs
Build-Depends:
 build-essential,
 cmake,
 git,
 debhelper,
 dh-make,
 quilt,
 fakeroot,
 lintian
Homepage: https://github.com/ibireme/yyjson

Package: libyyjson-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libyyjson (= ${binary:Version}), ${misc:Depends}
Description: A high performance JSON library written in ANSI C.

Package: libyyjson
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: A high performance JSON library written in ANSI C.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1
export DH_OPTIONS=-v
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

#include /usr/share/dpkg/architecture.mk


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed



#override_dh_auto_configure:
#	dh_auto_configure -- -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)"

include /usr/share/dpkg/architecture.mk
# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


clean:
	dh_testdir
	dh_testroot
	rm -fr CMakeFiles CMakeCache.txt Makefile cmake_install.cmake

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	touch configure-stamp

build: configure-stamp build-stamp
build-stamp:
	dh_testdir
	cmake .
	$(MAKE)
	touch build-stamp

install: build
	dh_testdir
	dh_update_autotools_config
	dh_autoreconf
	#dh_auto_configure
	install -d $(CURDIR)/debian/libyyjson/usr/lib/yyjson
	install -d $(CURDIR)/debian/libyyjson/etc/ld.so.conf.d/
	install $(CURDIR)/libyyjson.so $(CURDIR)/debian/libyyjson/usr/lib/yyjson/libyyjson.so.0.4.0
	install $(CURDIR)/etc/ld.so.conf.d/yyjsonlib.conf $(CURDIR)/debian/libyyjson/etc/ld.so.conf.d/yyjsonlib.conf
	install -d $(CURDIR)/debian/libyyjson-dev/usr/include
	install $(CURDIR)/src/yyjson.h $(CURDIR)/debian/libyyjson-dev/usr/include/yyjson.h

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

binary-arch: build install
	dh_testdir
	dh_testroot
#<----->dh_installdebconf<----->
	dh_installdocs
	dh_installexamples
	dh_installmenu
#<----->dh_installlogrotate
#<----->dh_installemacsen
#<----->dh_installpam
#<----->dh_installmime
#<----->dh_installinit
	dh_installcron
	dh_installman
	dh_installinfo
#<----->dh_undocumented
#<----->dh_installchangelogs ChangeLog
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#<----->dh_makeshlibs
	dh_installdeb
#<----->dh_perl
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## yyjson 0.8.0

=== CMakeLists.txt ===
# Copyright (C) 2019 Yaoyuan <ibireme@gmail.com>.
# Released under the MIT License:
# https://github.com/ibireme/yyjson/blob/master/LICENSE

cmake_minimum_required(VERSION 3.5)
project(yyjson VERSION 0.8.0 LANGUAGES C)



# ------------------------------------------------------------------------------
# Build Type
if(XCODE OR MSVC)
    set(CMAKE_CONFIGURATION_TYPES "Debug;Release" CACHE STRING "" FORCE)
endif()
if(NOT CMAKE_BUILD_TYPE)
    message(STATUS "No build type selected, default to: Release")
    set(CMAKE_BUILD_TYPE Release)
endif()



# ------------------------------------------------------------------------------
# Build Options for tests and docs
option(YYJSON_BUILD_TESTS "Build all tests" OFF)
option(YYJSON_BUILD_FUZZER "Build fuzzer" OFF)
option(YYJSON_BUILD_MISC "Build misc" OFF)
option(YYJSON_BUILD_DOC "Build documentation with doxygen" OFF)
option(YYJSON_ENABLE_COVERAGE "Enable code coverage for tests" OFF)
option(YYJSON_ENABLE_VALGRIND "Enable valgrind memory checker for tests" OFF)
option(YYJSON_ENABLE_SANITIZE "Enable sanitizer for tests" OFF)
option(YYJSON_ENABLE_FASTMATH "Enable fast-math for tests" OFF)
option(YYJSON_FORCE_32_BIT "Force 32-bit for tests" OFF)



# ------------------------------------------------------------------------------
# Compilation options, see yyjson.h for more explanation
option(YYJSON_DISABLE_READER "Disable JSON reader" OFF)
option(YYJSON_DISABLE_WRITER "Disable JSON writer" OFF)
option(YYJSON_DISABLE_UTILS "Disable JSON Pointer, JSON Patch, JSON Merge Patch" OFF)
option(YYJSON_DISABLE_FAST_FP_CONV "Disable custom floating-point number conversion" OFF)
option(YYJSON_DISABLE_NON_STANDARD "Disable non-standard JSON support" OFF)
option(YYJSON_DISABLE_UTF8_VALIDATION "Disable UTF-8 validation" OFF)
option(YYJSON_DISABLE_UNALIGNED_MEMORY_ACCESS "Disable unaligned memory access explicit" OFF)

if(YYJSON_DISABLE_READER)
    add_definitions(-DYYJSON_DISABLE_READER)
endif()
if(YYJSON_DISABLE_WRITER)
    add_definitions(-DYYJSON_DISABLE_WRITER)
endif()
if(YYJSON_DISABLE_UTILS)
    add_definitions(-DYYJSON_DISABLE_UTILS)
endif()
if(YYJSON_DISABLE_FAST_FP_CONV)
    add_definitions(-DYYJSON_DISABLE_FAST_FP_CONV)
endif()
if(YYJSON_DISABLE_NON_STANDARD)
    add_definitions(-DYYJSON_DISABLE_NON_STANDARD)
endif()
if(YYJSON_DISABLE_UTF8_VALIDATION)
    add_definitions(-DYYJSON_DISABLE_UTF8_VALIDATION)
endif()
if(YYJSON_DISABLE_UNALIGNED_MEMORY_ACCESS)
    add_definitions(-DYYJSON_DISABLE_UNALIGNED_MEMORY_ACCESS)
endif()



# ------------------------------------------------------------------------------
# Library
add_library(yyjson src/yyjson.h src/yyjson.c)
target_include_directories(yyjson PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>)
set_target_properties(yyjson PROPERTIES VERSION ${PROJECT_VERSION})



# ------------------------------------------------------------------------------
# Project Config
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(XcodeProperty)

if(XCODE)
    set(YYJSON_FLAGS "-Wall -Wextra -Werror -pedantic -pedantic-errors")
    if(YYJSON_ENABLE_FASTMATH)
        set(YYJSON_FLAGS "${YYJSON_FLAGS} -ffast-math")
    endif()
    
    set_default_xcode_property(yyjson)
    set_xcode_deployment_version(yyjson "10.13" "12.0" "12.0" "4.0")

    set_xcode_property(yyjson GCC_C_LANGUAGE_STANDARD "c89")
    set_xcode_property(yyjson CLANG_CXX_LANGUAGE_STANDARD "c++98")
    
    set_xcode_property(yyjson OTHER_CFLAGS[variant=Debug] ${YYJSON_FLAGS})
    set_xcode_property(yyjson OTHER_CFLAGS[variant=Release] ${YYJSON_FLAGS})
    
elseif(MSVC)
    set(YYJSON_FLAGS "/utf-8")
    if(YYJSON_ENABLE_FASTMATH)
        set(YYJSON_FLAGS "${YYJSON_FLAGS} /fp:fast")
    endif()
    
    target_compile_options(yyjson PRIVATE $<$<C_COMPILER_ID:MSVC>:${YYJSON_FLAGS}>)
    target_compile_options(yyjson PRIVATE $<$<CXX_COMPILER_ID:MSVC>:${YYJSON_FLAGS}>)
    
elseif(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang|Intel")
    set(YYJSON_FLAGS "")
    if(YYJSON_ENABLE_FASTMATH)
        set(YYJSON_FLAGS "-ffast-math")
    endif()
    
    target_compile_options(yyjson PRIVATE $<$<COMPILE_LANGUAGE:C>:${YYJSON_FLAGS}>)
    target_compile_options(yyjson PRIVATE $<$<COMPILE_LANGUAGE:CXX>:${YYJSON_FLAGS}>)
    
    if(YYJSON_FORCE_32_BIT)
        set(CMAKE_C_FLAGS -m32)
        set(CMAKE_CXX_FLAGS -m32)
    endif()

endif()

include(CheckIncludeFile)
check_include_file(stdint.h YYJSON_HAS_STDINT_H)
check_include_file(stdbool.h YYJSON_HAS_STDBOOL_H)

if(BUILD_SHARED_LIBS)
    if(WIN32)
        target_compile_definitions(yyjson PUBLIC
            $<BUILD_INTERFACE:YYJSON_EXPORTS>
            $<INSTALL_INTERFACE:YYJSON_IMPORTS>)
    endif()
endif()



# ------------------------------------------------------------------------------
# Install
include(GNUInstallDirs)

install(TARGETS yyjson
        EXPORT yyjson-targets
        ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
        INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
install(EXPORT yyjson-targets
        FILE yyjson-config.cmake
        NAMESPACE yyjson::
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/yyjson")
install(FILES src/yyjson.h DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")



# ------------------------------------------------------------------------------
# Testing
if(YYJSON_BUILD_TESTS)
    enable_testing()

    # Check C++ compiler
    include(CheckLanguage)
    check_language(CXX)
    if(CMAKE_CXX_COMPILER)
        enable_language(CXX)
    endif()
    
    if(XCODE)
        # Config XCTest
        find_package(XCTest REQUIRED)
        set(CMAKE_XCODE_ATTRIBUTE_CODE_SIGNING_ALLOWED "NO")
        set(CMAKE_XCODE_ATTRIBUTE_CODE_SIGNING_REQUIRED "NO")
        set(CMAKE_XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY "")
        set(YYJSON_TEST_DATA ${CMAKE_CURRENT_SOURCE_DIR}/test/data)
        
        # Add all test cases to XCTest: c files prefixed with 'test_'
        file(GLOB YYJSON_TEST_SOURCE
            "test/test_*.c"
        )
        set(YYJSON_TEST_LINES "")
        foreach(SRC_FILE ${YYJSON_TEST_SOURCE})
            string(REGEX REPLACE "(^.*/|\\.[^.]*$)" "" SRC_NAME ${SRC_FILE})
            set(YYJSON_TEST_LINES "${YYJSON_TEST_LINES}- (void)${SRC_NAME} {\n")
            set(YYJSON_TEST_LINES "${YYJSON_TEST_LINES}    extern void ${SRC_NAME}(void);\n")
            set(YYJSON_TEST_LINES "${YYJSON_TEST_LINES}    ${SRC_NAME}();\n")
            set(YYJSON_TEST_LINES "${YYJSON_TEST_LINES}}\n\n")
        endforeach()
        configure_file(
            "${CMAKE_CURRENT_SOURCE_DIR}/test/xctest/yy_xctest.m.in"
            "${CMAKE_CURRENT_SOURCE_DIR}/test/xctest/yy_xctest.m"
            @ONLY
        )
        unset(YYJSON_TEST_LINES)
        
        # Add source files and search path to XCTest
        file(GLOB YYJSON_TEST_SOURCE
            "test/test_*.c"
            "test/util/*.h"
            "test/util/*.c"
            "test/xctest/*"
        )
        xctest_add_bundle(yyjson_tests yyjson
            ${YYJSON_TEST_SOURCE}
            ${YYJSON_TEST_DATA}
        )
        set_target_properties(yyjson_tests PROPERTIES
            MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/test/xctest/Info.plist
            RESOURCE ${YYJSON_TEST_DATA}
        )
        target_include_directories(yyjson_tests PRIVATE
            ${CMAKE_CURRENT_SOURCE_DIR}/test/util
            ${CMAKE_CURRENT_SOURCE_DIR}/test/xctest
        )
        xctest_add_test(XCTest.yyjson yyjson_tests)
        
        set_default_xcode_property(yyjson_tests)
        set_xcode_deployment_version(yyjson_tests "10.13" "12.0" "12.0" "4.0")
        
    else()
        # Check valgrind command
        if (YYJSON_ENABLE_VALGRIND)
            find_program(MEMORYCHECK_COMMAND valgrind)
            if ("${MEMORYCHECK_COMMAND}" MATCHES "MEMORYCHECK_COMMAND-NOTFOUND")
                message(WARNING "Valgrind not found")
                unset(MEMORYCHECK_COMMAND)
            else()
                message(STATUS "Valgrind found")
                set(MEMORYCHECK_COMMAND_OPTIONS
                    --tool=memcheck
                    --leak-check=full
                    --trace-children=yes
                    --error-exitcode=1
                )
            endif()
        endif()
        
        # Copy test data
        file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/test/data" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
        add_definitions(-DYYJSON_TEST_DATA_PATH="${CMAKE_CURRENT_BINARY_DIR}")
        
        # Add dependency
        add_library(yyjson_test_utils
            test/util/yy_test_utils.c
            test/util/goo_double_conv.c
        )
        target_include_directories(yyjson_test_utils PUBLIC test/util)
        if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang")
            target_compile_options(yyjson_test_utils PRIVATE $<$<COMPILE_LANGUAGE:C>:-std=c99>)
        endif()
        
        # Add all test cases: c files prefixed with 'test_'
        file(GLOB YYJSON_TEST_SOURCE
            "test/test_*.c"
        )
        foreach(SRC_FILE ${YYJSON_TEST_SOURCE})
            string(REGEX REPLACE "(^.*/|\\.[^.]*$)" "" SRC_NAME ${SRC_FILE})
            add_executable(${SRC_NAME} ${SRC_FILE})
            target_link_libraries(${SRC_NAME} PRIVATE yyjson yyjson_test_utils)
            
            if(MSVC)
                target_compile_options(${SRC_NAME} PRIVATE $<$<C_COMPILER_ID:MSVC>:/utf-8>)
                target_compile_options(${SRC_NAME} PRIVATE $<$<CXX_COMPILER_ID:MSVC>:/utf-8>)
            endif()
            
            if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang")
                target_compile_options(${SRC_NAME} PRIVATE $<$<COMPILE_LANGUAGE:C>:-std=c99>)
            endif()
            
            if(MEMORYCHECK_COMMAND)
                add_test(NAME ${SRC_NAME}
                         COMMAND "${MEMORYCHECK_COMMAND}" ${MEMORYCHECK_COMMAND_OPTIONS} "${CMAKE_CURRENT_BINARY_DIR}/${SRC_NAME}")
            else()
                add_test(${SRC_NAME} ${SRC_NAME})
            endif()
            
            set_tests_properties(${SRC_NAME} PROPERTIES TIMEOUT 300)
            message(STATUS "Add test: ${SRC_NAME}")
        endforeach()
        
        # Add code coverage and sanitize
        if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang")
            if (YYJSON_ENABLE_COVERAGE)
                if(CMAKE_C_COMPILER_ID MATCHES "Clang")
                    set(COMPILE_FLAGS -fprofile-instr-generate -fcoverage-mapping)
                else()
                    set(COMPILE_FLAGS --coverage)
                endif()
                target_compile_options(yyjson PRIVATE ${COMPILE_FLAGS})
                target_link_libraries(yyjson INTERFACE ${COMPILE_FLAGS})
                foreach(SRC_FILE ${YYJSON_TEST_SOURCE})
                    string(REGEX REPLACE "(^.*/|\\.[^.]*$)" "" SRC_NAME ${SRC_FILE})
                    target_compile_options(${SRC_NAME} PRIVATE ${COMPILE_FLAGS})
                endforeach()
            endif()
            if (YYJSON_ENABLE_SANITIZE)
                set(COMPILE_FLAGS
                    -fsanitize=address
                    -fsanitize=undefined
                    -fsanitize=leak
                    -fsanitize-recover=all
                    -fno-omit-frame-pointer
                    -fno-optimize-sibling-calls
                    -O1
                    -g
                )
                target_compile_options(yyjson PRIVATE ${COMPILE_FLAGS})
                target_link_libraries(yyjson INTERFACE ${COMPILE_FLAGS})
            endif()
        endif()

    endif()
    
    
    # Test compatibility
    if(MSVC)
        add_executable(test_compile_ansi_c test/compile_ansi.c)
        target_include_directories(test_compile_ansi_c PRIVATE src)
        add_executable(test_compile_ansi_cpp test/compile_ansi.cpp)
        target_include_directories(test_compile_ansi_cpp PRIVATE src)
        
        # set warning level 4, treat warnings as errors

=== debian/changelog ===
yyjson (0.8.0-0deepin) unstable; urgency=medium

  * modify changelog and format

 -- zhangkun <zhangkun2@uniontech.com>  Thu, 23 Nov 2023 22:26:45 +0800

yyjson (0.8.0) UNRELEASED; urgency=medium

  * New upstream version
  * Add `YYJSON_SUBTYPE_NOESC` subtype to mark strings that do not need to be escaped.
  * Add `YYJSON_DISABLE_UTF8_VALIDATION` flag to allow disable UTF-8 validation at compile-time.
  * Add dynamic allocator API: `yyjson_alc_dyn_new()`, `yyjson_alc_dyn_free()`.
  * Add the missing `yyjson_mut_obj_add_arr/obj()` API: #140
  * Improve the write performance of strings with `YYJSON_SUBTYPE_NOESC`.
  * Fix clang-16 valgrind fail: #134
  * Fix compile break when both `FAST_FP` and `READER` are disabled

 -- zhangkun <zhangkun2@uniontech.com>  Tue, 03 Oct 2023 17:23:14 +0800

yyjson (0.7.0) UNRELEASED; urgency=medium

  * Initial Release.

 -- xiangzelong <xiangzelong@deepin.org>  Tue, 20 Jun 2023 16:30:45 +0800

=== debian/control ===
Source: yyjson
Priority: optional
Maintainer: unknown <xiangzelong@deepin.org>
Build-Depends: debhelper-compat (= 13),
                libmpfr-dev,
                libgmp-dev,
                cmake,
Standards-Version: 4.6.0
Section: libs
Homepage: https://github.com/ibireme/yyjson
Rules-Requires-Root: no

Package: yyjson-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: yyjson (= ${binary:Version}), ${misc:Depends}
Description: A high performance JSON library written in ANSI C.

Package: yyjson
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: A high performance JSON library written in ANSI C.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@


# dh_make generated override targets
# This is example for Cmake (See https://bugs.debian.org/641051 )
override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_SHARED_LIBS=ON \
	-DYYJSON_BUILD_TESTS=ON \

## yyjson 0.9.0+ds

=== debian/changelog ===
yyjson (0.9.0+ds-2) unstable; urgency=medium

  * Source only upload.

 -- Carlos Henrique Lima Melara <charlesmelara@riseup.net>  Thu, 30 May 2024 15:22:46 -0300

yyjson (0.9.0+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #972804)

 -- Carlos Henrique Lima Melara <charlesmelara@riseup.net>  Tue, 14 May 2024 01:14:30 -0300

## yyjson 0.10.0

=== debian/changelog ===
yyjson (0.10.0-0deepin1) unstable; urgency=medium

  * New upstream version
  * Add `yyjson_locate_pos()` function to locate the line and column number
    for error position: #166
  * Improve error messages for JSON reader: #168
  * Fix `YYJSON_READ_NUMBER_AS_RAW` not overriding `YYJSON_READ_BIGNUM_AS_RAW`
    as per documentation: #170

 -- Amaro Martínez <xoas@airmail.cc>  Tue, 03 Sep 2024 01:18:47 -0500

yyjson (0.9.0) UNRELEASED; urgency=medium

  * New upstream version
  * Add `YYJSON_WRITE_NEWLINE_AT_END` flag for JSON writer: #147
  * Add auto-type conversion (uint<->sint) to `yyjson_ptr_get_uint/sint()`: #152
  * Fix incorrect output in environments lacking native `bool` type support: #161

 -- Amaro Martínez <xoas@airmail.cc>  Mon, 02 Sep 2024 10:53:50 -0500

=== debian/control ===
Source: yyjson
Section: libs
Priority: optional
Maintainer: unknown <xiangzelong@deepin.org>
Uploaders: Amaro Martínez <xoas@airmail.cc>,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
                libmpfr-dev,
                libgmp-dev,
                cmake,
Homepage: https://github.com/ibireme/yyjson

Package: libyyjson-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libyyjson0 (= ${binary:Version}), ${misc:Depends}
Description: high performance JSON library written in ANSI C (development files)
 The fastest JSON library in C.

Package: libyyjson0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: high performance JSON library written in ANSI C
 The fastest JSON library in C.

Package: yyjson-dev
Section: oldlibs
Architecture: any
Multi-Arch: same
Depends: libyyjson-dev, ${misc:Depends}
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: yyjson
Section: oldlibs
Architecture: any
Multi-Arch: same
Depends: libyyjson0 (= ${binary:Version}), ${misc:Depends}
Description: transitional package
 This is a transitional package. It can safely be removed.

## yyjson 0.10.0+ds

=== debian/changelog ===
yyjson (0.10.0+ds-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 22 Aug 2024 19:45:33 -0700

yyjson (0.10.0+ds-1) unstable; urgency=medium

  * New upstream version 0.10.0+ds.
  * debian/libyyjson0.symbols: add symbols from new release.

 -- Carlos Henrique Lima Melara <charlesmelara@riseup.net>  Tue, 23 Jul 2024 22:54:50 +0900

=== debian/control ===
Source: yyjson
Section: libs
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Carlos Henrique Lima Melara <charlesmelara@riseup.net>
Uploaders: Hiago De Franco <hiagofranco@gmail.com>,
           Maytham Alsudany <maytha8thedev@gmail.com>
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 13),
               doxygen <!nodoc>,
               graphviz <!nodoc>
Standards-Version: 4.7.0
Homepage: https://github.com/ibireme/yyjson
Vcs-Browser: https://salsa.debian.org/debian/yyjson
Vcs-Git: https://salsa.debian.org/debian/yyjson.git

Package: libyyjson-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libyyjson0 (= ${binary:Version}), ${misc:Depends}
Suggests: libyyjson-doc
Description: high performance JSON library written in ANSI C (development files)
 Some features of the library are:
 .
  - Fast: can read or write gigabytes per second JSON data on modern CPUs.
  - Portable: complies with ANSI C (C89) for cross-platform compatibility.
  - Strict: complies with RFC 8259 JSON standard, ensuring strict number format
    and UTF-8 validation.
  - Extendable: offers options to allow comments, trailing commas, NaN/Inf, and
    custom memory allocator.
  - Accuracy: can accurately read and write int64, uint64, and double numbers.
  - Flexible: supports unlimited JSON nesting levels, \u0000 characters, and
    non null-terminated strings.
  - Manipulation: supports querying and modifying using JSON Pointer, JSON
    Patch and JSON Merge Patch.
  - Developer-Friendly: easy integration with only one .h and one .c file.
 .
 This package contains the development files for libyyjson.

Package: libyyjson-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: high performance JSON library written in ANSI C (documentation)
 Some features of the library are:
 .
  - Fast: can read or write gigabytes per second JSON data on modern CPUs.
  - Portable: complies with ANSI C (C89) for cross-platform compatibility.
  - Strict: complies with RFC 8259 JSON standard, ensuring strict number format
    and UTF-8 validation.
  - Extendable: offers options to allow comments, trailing commas, NaN/Inf, and
    custom memory allocator.
  - Accuracy: can accurately read and write int64, uint64, and double numbers.
  - Flexible: supports unlimited JSON nesting levels, \u0000 characters, and
    non null-terminated strings.
  - Manipulation: supports querying and modifying using JSON Pointer, JSON
    Patch and JSON Merge Patch.
  - Developer-Friendly: easy integration with only one .h and one .c file.
 .
 This package contains the documentation files for libyyjson.

Package: libyyjson0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: high performance JSON library written in ANSI C
 Some features of the library are:
 .
  - Fast: can read or write gigabytes per second JSON data on modern CPUs.
  - Portable: complies with ANSI C (C89) for cross-platform compatibility.
  - Strict: complies with RFC 8259 JSON standard, ensuring strict number format
    and UTF-8 validation.
  - Extendable: offers options to allow comments, trailing commas, NaN/Inf, and
    custom memory allocator.
  - Accuracy: can accurately read and write int64, uint64, and double numbers.
  - Flexible: supports unlimited JSON nesting levels, \u0000 characters, and
    non null-terminated strings.
  - Manipulation: supports querying and modifying using JSON Pointer, JSON
    Patch and JSON Merge Patch.
  - Developer-Friendly: easy integration with only one .h and one .c file.
 .
 This package contains the shared library.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_SHARED_LIBS=ON \
	-DYYJSON_BUILD_DOC=ON \
	-DYYJSON_BUILD_TESTS=ON

# No dbgsym packages:
override_dh_strip:
	@echo "not building dbgsym packages for MX Linux"
	dh_strip --no-automatic-dbgsym

## yyjson 0.12.0%2Bds

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_SHARED_LIBS=ON \
	-DYYJSON_BUILD_DOC=ON \
	-DYYJSON_BUILD_TESTS=ON
